# next-jd

Get the next available ID number for your [Johnny Decimal](https://johnnydecimal.com/) system and add your new item to the Index at the same time

## Wishlist

That which has not yet come to be.

### Scripting Languages

Because choices are good

* A shell script
* A Python script

### Functionalities

#### What do we want it to do?

1. Ask the user to select the Area and Category. 
  1.1 Offer the user a list of current Areas/Categories to select by number
  1.2. If a selected slot is labeled `[unused]`, ask the user to supply a name and update the Index
2. Ask the user to name the new ID
3. Give the user their new ID complete with name for easy copy/paste
4. Update the relevant files
5. If the user is using a previously unused slot, move the directory to match (ask first?)
6. Read in an `options.yaml` file to allow the user to set their own defaults for things (never, always, ask each time)

#### How do we want to store the data?

* Store the data in JSON; Generate a new Index each time, or don't, and let the user manually update the Index; offer the option
  * This option would allow a local JS-flavored web view of the Index
* Store the data in the text Index; update the Index whenever a new ID is generated; can break the script if the Index format gets screwed up
* Store the data in a database; this is most likely overkill

## "Done" List

That which has been completed

There is nothing here right now. You may contribute if you wish. Merge requests are welcomed.